{
  pkgs,
  config,
  lib,
  ...
}:
with lib;
{
  options.jade.editors = {
    zed.enable = mkEnableOption "Enable Zed Editor";
  };
  config = mkIf config.jade.editors.zed.enable {
    home-manager.users.jade =
      { pkgs, ... }:
      {
        programs.zed-editor = {
          enable = true;
          extraPackages = [
            (pkgs.rustPlatform.buildRustPackage rec {
              pname = "discord-presence-lsp";
              version = "d6622e5d4dbbf9f61764458c2b50ba2e58789307";
              cargoHash = "sha256-JLNCEeo9fKeV4vTtPs+Yj2wRO1RKP2fuetrPlXcPBjA=";

              src = pkgs.fetchFromGitHub {
                owner = "xhyrom";
                repo = "zed-discord-presence";
                rev = version;
                hash = "sha256-RmpY0xkJYNDYn6SWNdKGpPetmBxf2/xY25FLeJqf0Po=";
              };

              cargoBuildFlags = "--package discord-presence-lsp";
            })
          ];
          extensions = [
            "discord-presence" # yes, i sunk that low
            "nix"
            "nu"
          ];
          userSettings = {
            features = {
              edit_prediction_provider = null;
            };
            show_edit_predictions = false;
            middle_click_paste = false;
            search = {
              regex = true;
            };
            inlay_hints = {
              enabled = true;
            };
            assistant = {
              version = "2";
              enabled = false;
            };
            diagnostics = {
              include_warnings = false;
              inline = {
                enabled = true;
                update_debounce_ms = 150;
                padding = 4;
                min_column = 0;
                max_severity = null;
              };
            };
            language_models = null;
            vim_mode = true;
            vim = {
              default_mode = "helix_normal";
            };
            # ui_font_size = 16;
            # WHY CAN I NOT OVERRIDE THIS
            # habt'a lack gesoffen?!
            # buffer_font_size = 16.;
          };
        };
      };
  };
}
